

import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.net.URL;

public class T9 implements ActionListener {
	
	private static String numbers="";
		private static int numberOfWordsInDictionary=0;
	private static String[] words; // all the words from text file, each at an index in this array.
private static String[] chars = {"", "", "abc", "def", "ghi", "jkl", "mno", "pqrs", "tuv", "wxzy"};
private static String[] foundWords; // an array containing the values returned by getT9 method.
private static int curWord=0;

// For GUI:
	private static JFrame f=null;
	private static JLabel label1 = null;
	private static JLabel label2 = null;
		// An array for all 12 Buttons:
	private static JButton[] b = new JButton[13]; // index 0 will remain empty.
	
	// Constants.
	private static final String initLabel1 = "Bine ai venit!";
	private static final String initLabel2 = "Taste apsate";
	private static final String noMatches="Fr potriviri!";

	// The create gui method: 
	public void tGui() {
		
		if(f==null) {
int fs = 30; // the font size of the labels.

			// Variables for size and resize the JFrame and JButtons:
			int height=60; // the height of the buttons.
			int width=100; // the width of the buttons.
									int spacing=10; // the distance between buttons, and between buttons + labels and frame edges.
						int x=spacing; // the x coordinates for the buttons..
						int y=(height*2)+(spacing*3); // the y coordinate for the first row of buttons.
						int jfHeight=(height*6)+(spacing*7)+(spacing*3)+(spacing/2); // the height of the entire frame.
			int jfWidth=(width*3)+(spacing*4)+spacing+(spacing/2); // the width of the entire frame.
			
			f = new JFrame("T9 Editor by Manu");
			f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			f.setSize(jfWidth, jfHeight);
			f.setLocation(100,100);
			f.setLayout(null);
			
			// Create 2 labels:
			label1 = new JLabel(initLabel1);
label1.setSize((width*3)+(spacing*2), height);
label1.setLocation(spacing, spacing);
label1.setFont(new Font("Serif", Font.PLAIN, fs));
			f.add(label1);
			
			label2 = new JLabel(initLabel2);
			label2.setSize((width*3)+(spacing*2), height);
			label2.setLocation(spacing, height+(spacing*2));
			label2.setFont(new Font("Serif", Font.PLAIN, fs));
			f.add(label2);
			
			// Buttons names in an array:
			String[] bNames = new String[] {"", "1 Despre", "2 ABC", "3 DEF", "4 GHI", "5 JKL", "6 MNO", "7 PQRS", "8 TUV", "9 WXYZ", "* Schimb", "0 Reset", "# terg"};
			
			// Create buttons:
						for(int i=1; i<b.length; i++) {
				
				// Set the coordinates at runtime:
								// 3 by 3 buttons, 3 on a row:
								if(i%3==1&&i!=1) {
				x=spacing;
				y+=(height+spacing);
										}
															
																			b[i] = new JButton(bNames[i]);
			b[i].setSize(width, height);
			b[i].setFont(new Font("Serif", Font.PLAIN, 18));
					b[i].setLocation(x, y);
										b[i].addActionListener(new T9());
					b[i].setActionCommand(""+i);
													
					f.add(b[i]);
					
					// For the orizontal x for buttons:
					x+=(width+spacing);
			} // end for, a loop to create the buttons dynamically.

						resetAllValues(); // An user defined method.
					
						setMnemonicKeys(); // an user defined method.
						
							f.setVisible(true);
					
		} // end if f is null.
	} // end tGui create gui method.
	
	
	 	public static void main(String[] args) {
	 		
	 		T9 t9 = new T9();
			t9.setInit(); 		
	 		t9.tGui();
	 	} // end void main.
	 	
	 	private void setMnemonicKeys() {
	 		 		b[2].setMnemonic(KeyEvent.VK_2);
	 		b[3].setMnemonic(KeyEvent.VK_3);
	 		b[4].setMnemonic(KeyEvent.VK_4);
	 		b[5].setMnemonic(KeyEvent.VK_5);
	 		b[6].setMnemonic(KeyEvent.VK_6);
	 		b[7].setMnemonic(KeyEvent.VK_7);
	 		b[8].setMnemonic(KeyEvent.VK_8);
	 		b[9].setMnemonic(KeyEvent.VK_9);
	 		b[10].setMnemonic(KeyEvent.VK_S);
	 		b[11].setMnemonic(KeyEvent.VK_R);
	 		b[12].setMnemonic(KeyEvent.VK_D);
	 				 	} // end setMnemonicKeys.
	 		 	
	 	// Set initial values:
	 	private void setInit() {
	 	    	 		// Get the dictionary file and split it into words array:
	 		String temp=null;
	 		String         ls = System.getProperty("line.separator");
	 		
try {
		//File file = new File("Romanian.txt");
	InputStream input = getClass().getResourceAsStream("Romanian.txt");
//BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(file), "UTF-8"));
BufferedReader br = new BufferedReader(new InputStreamReader(input, "UTF-8"));
StringBuilder sb = new StringBuilder();
String line=null;
	 		    while((line = br.readLine()) != null) {
sb.append(line);
sb.append(ls);
	 		        	 		    } // end while.
	 		   temp=sb.toString();
	 		            br.close();
} catch (IOException ex) {
		ex.printStackTrace();		
		 			 		}
							 		 		
 		 	words = temp.split(ls);
 		 	numberOfWordsInDictionary=words.length;
 		 				 			 					 		} // end setInit function.
	 	
	 	private void resetAllValues() {
    		label1.setText(initLabel1);
    		label2.setText(initLabel2);
			b[10].setEnabled(false);
			b[11].setEnabled(false);
			b[12].setEnabled(false);
    		numbers="";
curWord=0;
    			 	}
	 		
	 	// The function to process, occurs after a button between 2 and 9 or # is pressed:
	 	private void processAfterButtons(String num) {
	 		if(num=="backspace") {
	 			numbers = numbers.substring(0, numbers.length()-1); // trim the las digit, to simulate the backspace.
	 		} else {
	 			numbers+=num;	
	 		}
	 		label2.setText(numbers);
	 		foundWords = getT9Words(numbers);
 			 			 		 	 		num=null;
 			 			 		 	 		// Enable the button if there are more than one result, false otherwise:
 			 			 		 	 		int curWordsLength=foundWords.length;
 			 			 		 	 		if(curWordsLength==1) {
 			 			 		 	 			b[10].setEnabled(false);
 			 			 		 	 		} else {
 			 			 		 	 		b[10].setEnabled(true);
 			 			 		 	 		}
	 		showWords(0);
	 			 			 			 	}

	 	private void switchWords() {
	 		int curWordsLength=foundWords.length;
	 			 		if(curWord<curWordsLength-1) {
	 			curWord++;
	 			 		} else {
	 			curWord=0;
	 		}
	 			 		
	 			 		showWords(curWord);
	 			 	}
	 		 	
	 	private void showWords(int which) {
	 				 				String toShow=foundWords[which]; 		 		
	 				 				label1.setText(toShow);
	 	}
	 	
	 // The core method , which determine a word from dictionary:
	 private String[] getT9Words(String nums) {
	 StringBuilder sb = new StringBuilder(); // to create the temp string delimited by "|" pipes.
		 String temp=null; // the string containing the word delimited by vertical bars.
		 
	 int numberOfDigits=nums.length();
	 
	 // Create the temp variable with matches:
	 for(int i=0; i<numberOfWordsInDictionary; i++) {
	 if(words[i].length()==numberOfDigits) {
	 String curWord=words[i];
	 boolean isWord=true;
	 for(int j=0; j<numberOfDigits; j++) {
	 boolean isChar=false;
	 int numIndex=Integer.parseInt(Character.toString(nums.charAt(j)));
	 String numChars=chars[numIndex];

	 // Now let's check if is a char on position:
	 for(int k=0; k<numChars.length(); k++) {
	 if(curWord.charAt(j)==numChars.charAt(k)) {
	 isChar=true;
	 break;
	 } // end if.
	 } // end for checking each character in a numChars..

	 if(!isChar) {
	 isWord=false;
	 break;
	 }
	 } // end for searching on each position of the word.

	 if(isWord) {
	sb.append(words[i]);
	sb.append("|");
		 }
	 } // end if is a possible word because same number of characters like digits entered.
	 } // end for loop through all the dictionary.

	 // The array to be returned:
	temp=sb.toString();
	
		 // Delete last vertical bar if needed:
	  if (temp.length()>0&&temp.charAt(temp.length()-1)=='|') {
		    temp = temp.substring(0, temp.length()-1);
	  }
	  else {
		  // No matches found, set a value manually:
		  temp=noMatches;
	  }
		  	 
	 	 String[] word;
	 word=temp.split("\\|");
	 		 return word;
	 }
 	
	 	 	// For buttons events:
	    @Override
		public void actionPerformed(ActionEvent ae) {
	    	
	    	String sAct = ae.getActionCommand();
	    	int act =Integer.parseInt(sAct); 
    	   	
	    		    	if(act==1) {
	    		    		JOptionPane.showMessageDialog(f, "Creat n Java.\nAutor: Emanuel Boboiu.\n22 septembrie 2013\nwww.pontes.ro");
	    		    	} else if(act==10) {
	    	switchWords();
	    		    	    		    	} else if(act==11) {
	    			    			    			    		resetAllValues();
	    		    	    		    	} else if(act==12) {
// to know that's a backspace:
   		    	    		    		processAfterButtons("backspace");
	    	    		    	} else if(act>1&&act<10) {
	    			    		processAfterButtons(""+act);
	    			    				    		    	}

	// The # (backspace)  and 0 (reset) button are available only if numbers is not empty:
    	if(numbers.length()>0) {
    		b[11].setEnabled(true);
    		b[12].setEnabled(true);
    	} else {
resetAllValues();    		
    	}
    	    	
	
	    } // end events function.

} // end T9 class.
